﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Warship
{
    internal class SetWarshipsGeneric<T>
        where T : class
    {
        private readonly T[] _places;

        public int Count => _places.Length;

        public SetWarshipsGeneric(int count)
        {
            _places = new T[count];
        }

        public int Insert(T warship)
        {
            return Insert(warship,0);
        }
        
        public int Insert(T warship, int position)
        {
            int EmptyEl=-1;

            if (position>=Count || position < 0)
                return -1;

            if (_places[position] == null)
            {
                _places[position] = warship;
                return 1;
            }

            else if (_places[position] != null)
            {
                for (int i = position + 1; i < Count; i++)
                    if (_places[i] == null)
                    {
                        EmptyEl = i;
                        break;
                    }

                if (EmptyEl == -1)
                    return -1;

                for (int i = EmptyEl; i > position; i--)
                    _places[i] = _places[i - 1];
            }

            _places[position] = warship;
            return 1;
        }

        public T Remove(int position)
        {
            if (position >= Count || position < 0 || _places[position]==null)
                return null;

            T deleted =_places[position];
            _places[position] = null;
            return deleted;
        }

        public T Get(int position)
        {
            if (position >= Count || position < 0)
                return null;

            return _places[position];
        }
    }
}
